<img width='100%' src='https://firebasestorage.googleapis.com/v0/b/library-of-lenses.appspot.com/o/images%2FLens%20image%20top%20raw.jpg?alt=media&token=96912b29-e29a-42e2-b736-8c1b4d8ecb89'>

# Library of Lenses

View over at: https://library-of-lenses.web.app/welcome (Use a Web Browser for best 3D Experience)

_This is the place to learn about different vintage lenses and my experience with them. Some are obscure, others quite common – from cult classics to stuff with zero information online, stop by and browse the library._

This project is a replica of www.libraryoflenses.com, built from scratch. The main aim was to learn more about TypeScript, Three.js fiber and GSAP, as well as improve the admin experience, as opposed to wordpress and the many steps it took to post a review.

## Main Technologies:

<div align="center">
<code><img width="70" src="https://user-images.githubusercontent.com/25181517/183890598-19a0ac2d-e88a-4005-a8df-1ee36782fde1.png" alt="TypeScript" title="TypeScript"/></code>
	  <code><img width="70" src="https://user-images.githubusercontent.com/25181517/117447155-6a868a00-af3d-11eb-9cfe-245df15c9f3f.png" alt="JavaScript" title="JavaScript"/></code>
      	<code><img width="70" src="https://user-images.githubusercontent.com/25181517/183897015-94a058a6-b86e-4e42-a37f-bf92061753e5.png" alt="React" title="React"/></code>
	<code><img width="70" src="https://user-images.githubusercontent.com/25181517/192158954-f88b5814-d510-4564-b285-dff7d6400dad.png" alt="HTML" title="HTML"/></code>
	<code><img width="70" src="https://user-images.githubusercontent.com/25181517/183898674-75a4a1b1-f960-4ea9-abcb-637170a00a75.png" alt="CSS" title="CSS"/></code>
	<code><img width="70" src="https://user-images.githubusercontent.com/25181517/189716855-2c69ca7a-5149-4647-936d-780610911353.png" alt="Firebase" title="Firebase"/></code>
	<code><img width="70" src="https://user-images.githubusercontent.com/25181517/189716630-fe6c084c-6c66-43af-aa49-64c8aea4a5c2.png" alt="Material UI" title="Material UI"/></code>
        <code><img width="70" src="https://user-images.githubusercontent.com/25181517/192108376-c675d39b-90f6-4073-bde6-5a9291644657.png" alt="GitLab" title="GitLab"/></code>
</div>

### Additional Technologies:

-   Zustand - Used for state management.
-   gltfjsx - to convert the 3D .glb file to a reusable component
-   Three.js fiber - Used for the 3D models on the landing page
-   Three.js drei - Used for scroll animation on the 3D models on the landing page
-   gsap - Used to animate the 3D models on the landing page
-   react-hook-form - Used to manage forms on login,register and review creation page
-   yup - For schema validation on register form

### Attibutions:

-   404 Page not found image - <a href="https://www.freepik.com/free-vector/404-error-with-landscape-concept-illustration_20824299.htm#query=404&position=13&from_view=search&track=sph">Image by storyset</a> on Freepik
-   3D Model - by Karan Sahu (https://sketchfab.com/cgkaran) It can be found here: https://sketchfab.com/3d-models/dslr-camera-lens-60bfdc6a3c884b91ae4f8ebd3f750a88
